// https://www.shadertoy.com/view/MdlXz8

const fragment = /* glsl */ `#version 300 es
precision highp float;

uniform vec2 u_resolution;
uniform vec2 u_mouse;
uniform float u_time;
out vec4 outColor;

#define TAU 8.
#define MAX_ITER 10

void main() 
{
	float time = u_time * .5+23.0;
 	vec2 uv = gl_FragCoord.xy / u_resolution.xy;    
    vec2 p = mod(uv*TAU, TAU)-200.0;
	vec2 i = vec2(p);
	float c = 1.0;
	float inten = .005;

	for (int n = 0; n < MAX_ITER; n++) 
	{
		float t = time * (1.0 - (3.5 / float(n+1)));
		i = p + vec2(cos(t - i.x) + sin(t + i.y), sin(t - i.y) + cos(t + i.x));
		c += 1.0/length(vec2(p.x / (sin(i.x+t)/inten),p.y / (cos(i.y+t)/inten)));
	}
	c /= float(MAX_ITER);
	c = 1.17-pow(c, 1.4);
	vec3 colour = vec3(pow(abs(c), 10.0));
    colour = clamp(colour + vec3(0.0, 0.35, 0.5), 0.0, 1.0);
    
	outColor = vec4(colour, 1.);
}
`;

export default fragment;